﻿/*
AwesomeNET by xeetsh - Maximilian T. Schmitt

Licensed under the Unity Asset Store Terms of Service and EULA. See https://unity3d.com/legal/as_terms for a complete version of the license

AwesomeNET Doccumentation: https://docs.awesomenet.xeet.sh
Contact/Support/Feature requests: https://xeet.sh/contact.php
Twitter: @xeetsh
*/

using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEditor;

[CustomEditor(typeof(NetworkController))]
public class NetworkControllerEditor : Editor {

    public override bool RequiresConstantRepaint() {
        return true;
    }

    public override void OnInspectorGUI() {
        base.OnInspectorGUI();
        
        // Font Styles
        GUIStyle styleBold = new GUIStyle();
        styleBold.fontStyle = FontStyle.Bold;

        NetworkController nc = (NetworkController) target;

        EditorGUI.BeginChangeCheck();

        // Matchmaking
        EditorGUILayout.LabelField("Matchmaking", styleBold);
        EditorGUILayout.LabelField("Status: " + (nc.m_connected ? "Connected" : "Offline"));
        if (nc.m_connected) {
            EditorGUILayout.LabelField("IP: " + nc.m_mmc.m_host.ToString());
            EditorGUILayout.LabelField("Port: " + nc.m_mmc.m_port.ToString());
        }

        // Gameserver
        EditorGUILayout.LabelField("Gameserver", styleBold);
        EditorGUILayout.LabelField("Status: " + (nc.m_gc != null && nc.m_gc.m_connected ? "Connected" : "Offline"));
        if (nc.m_gc != null && nc.m_gc.m_connected) {
            EditorGUILayout.LabelField("IP: " + nc.m_gc.m_host.ToString());
            EditorGUILayout.LabelField("Port: " + nc.m_gc.m_port.ToString());
            EditorGUILayout.LabelField("GameID: " + nc.m_gc.m_id.ToString());

            // Game
            EditorGUILayout.LabelField("Game", styleBold);
            GameInfo gi = nc.GetCurrentGameInfo();
            EditorGUILayout.LabelField("Map: " + gi.map);
            EditorGUILayout.LabelField("Host: " + gi.host);
            string players = "";
            foreach (string player in gi.players) {
                players += player + " ";
            }
            EditorGUILayout.LabelField("Players: " + players + "(" + gi.playercount + ")");
        }
    }
}
