﻿/*
AwesomeNET by xeetsh - Maximilian T. Schmitt

Licensed under the Unity Asset Store Terms of Service and EULA. See https://unity3d.com/legal/as_terms for a complete version of the license

AwesomeNET Doccumentation: https://docs.awesomenet.xeet.sh
Contact/Support/Feature requests: https://xeet.sh/contact.php
Twitter: @xeetsh
*/

using System.Collections;
using System.Collections.Generic;
using System.Net;
using System.Net.Sockets;
using System;
using UnityEngine;
using System.Threading;
using System.Threading.Tasks;


public class GameClient : TCPClient {
    private Thread m_t;
    public bool m_connected = false;
    private NetworkController m_nc;
    public string m_id;
    public GameClient(string host, int port, NetworkController nc, string id) : base(host, port) {
        m_connected = true;
        m_t = new Thread(ListeningThread);
        this.m_nc = nc;
        this.m_id = id;
    }

    void ListeningThread() {
        while (m_connected) {
            if (AnalyzeMessage(Receive()) == (int) CCType.GameData) {
                m_nc.ExecuteGSCommand(m_lastArgv);
            }
        }
    }

    public void Send(string objectID, string actionID, byte[] argument) {
        string[] argv = new string[3];
        argv[0] = objectID;
        argv[1] = actionID;
        argv[2] = System.Text.Encoding.ASCII.GetString(argument);

        Send((int) CCType.GameData, argv);
    }

    public override void OnConnect() {
        PrintMessage(string.Format("Connected to gameserver on {0}:{1}", m_host, m_port), MessageTypes.Notification);

        m_t.Start();
    }
    public override void OnDisconnect() {
        PrintMessage("Disconnected from gameserver", MessageTypes.Notification);

        m_connected = false;
    }
    public override string GetServerType(bool uppercase) {
        if (uppercase)
            return "Game";
        else
            return "game";
    }
}
